#ifndef PEBBLISP_HASH_H
#define PEBBLISP_HASH_H

#include "object.h"

struct ObjectTable {
    size_t count;
    size_t capacity;
    struct EnvElement* elements;
};

struct ObjectTable buildTable(size_t capacity);

/// Returns the hash of the inserted object
size_t addToTable(struct ObjectTable* table, char* name, Object object);

struct StrippedObject* getWithHash(struct ObjectTable* table, size_t hash);

struct StrippedObject* getFromTable(struct ObjectTable* table, const char* name);

void deleteTable(struct ObjectTable* table);

#endif //PEBBLISP_HASH_H
